VERSION 5.00
Begin VB.Form Form1 
   AutoRedraw      =   -1  'True
   Caption         =   "Click Me repeatedly!"
   ClientHeight    =   5955
   ClientLeft      =   120
   ClientTop       =   465
   ClientWidth     =   9840
   LinkTopic       =   "Form1"
   ScaleHeight     =   5955
   ScaleWidth      =   9840
   StartUpPosition =   3  'Windows-Standard
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
'VB has no problems, to serialize/deserialize the nested tTest-UDT below...
'(even when those UDT-Defs contain members with a dynamic length, as Strings or Arrays)
'It can do that over its Put and Get functions, but these are restricted to
'Files only... well, this example shows how to use a named Pipes FileName to
'work around that, to keep VBs nice serialization/deserialization-feature InMemory...

Private Type tTestSubType
  S As String
  B() As Byte
End Type

Private Type tTest
  L As Long
  S As String
  B() As Byte
  SubType As tTestSubType
End Type

Private TSrc As tTest, TDst As tTest 'two UDT-vars of the same Type (TDst will be used for Deserialization)

Private WithEvents PipedUDTs As cPipedUDTs
Attribute PipedUDTs.VB_VarHelpID = -1

Private Sub Form_Load()
  Set PipedUDTs = New cPipedUDTs   'instantiate the Helper-class WithEvents
      PipedUDTs.Init "vbPipedUDTs" 'init with a Pipe-Suffix of your own choice
End Sub

Private Sub Form_Click()
Static cc As Long: cc = cc + 1 'increment a static Counter-Value

'fill in some Demo-Values into TSrc (it will be deserialized later into TDst)
    With TSrc
      .L = cc
      .S = "String-" & cc
      .B = "ByteArray-Content " & cc
      .SubType.S = "SubType-String-" & cc
      .SubType.B = "SubType-ByteArray-Content " & cc
    End With
  
'first the serialization of TSrc into B()
    Dim B() As Byte
    PipedUDTs.SerializeToBytes B 'note, that the Source-Type itself has to be specified in the matching Event
 
'... now the content of TSrc is serialized in B() ... we can put B() into a resource or a DB-Blob-Field or transfer it over Sockets
  
'now the deserializaion of B() back into the same Type of Struct - here into TDst
    PipedUDTs.DeserializeFromBytes B 'note, that the Dest-Type has to be specified in the matching Event, too
    
    With TDst 'print out, what we got from our serializations of TSrc -> over B() -> into TDst
      Print .L, .S, .B, .SubType.S, .SubType.B
    End With
End Sub

Private Sub PipedUDTs_SerializePutFNr1SrcType(ByVal FNr As Long)
  Put FNr, 1, TSrc 'an Event which requires VBs Put call, so that you can serialize any (arbitrary) UDT here
End Sub

Private Sub PipedUDTs_DeserializeGetFNr1DstType(ByVal FNr As Long)
  Get FNr, 1, TDst 'and one for the opposite direction, to deserialize into arbitrary UDT-Variable-Types
End Sub
